Imports PCBI
Imports PCBI.Automation
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.IO
Imports System.Windows.Forms

Namespace Demo5CSharp
	Public Class Form1
		Inherits Form

		Friend Class ExampleSurface
			Friend Class Grf_Object
			End Class

			Friend Class Grf_Line
				Inherits Form1.ExampleSurface.Grf_Object

				Friend Start As PointF

				Friend [End] As PointF
			End Class

			Friend Class Grf_Arc
				Inherits Form1.ExampleSurface.Grf_Object

				Friend Start As PointF

				Friend [End] As PointF

				Friend Center As PointF

				Friend Clockwise As Boolean = True
			End Class
		End Class

		Private components As IContainer = Nothing

        Private WithEvents button1 As Button

        Protected Sub Dispose(ByVal disposing As Boolean)
            If disposing AndAlso Me.components IsNot Nothing Then
                Me.components.Dispose()
            End If
            MyBase.Dispose(disposing)
        End Sub

        Private Sub InitializeComponent()
            Me.button1 = New Button()
            MyBase.SuspendLayout()
            Me.button1.Location = New Point(12, 12)
            Me.button1.Name = "button1"
            Me.button1.Size = New Size(260, 87)
            Me.button1.TabIndex = 0
            Me.button1.Text = "Demo 5: how to add new pad specifications"
            Me.button1.UseVisualStyleBackColor = True
            MyBase.AutoScaleDimensions = New SizeF(6.0F, 13.0F)
            MyBase.AutoScaleMode = AutoScaleMode.Font
            MyBase.ClientSize = New Size(284, 113)
            MyBase.Controls.Add(Me.button1)
            MyBase.Name = "Form1"
            Me.Text = "Demo 5"
            MyBase.ResumeLayout(False)
        End Sub

        Public Sub New()
            Me.InitializeComponent()
        End Sub

        Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
            IAutomation.IAutomationInit()
            Dim mainWindowPCBI As IPCBIWindow
            If File.Exists("D:\tests\PCB-Investigator-Design.exe") Then
                mainWindowPCBI = IAutomation.OpenEmbeddedDesign("D:\tests\PCB-Investigator-Design.exe", True)
            Else
                Dim openDLG As OpenFileDialog = New OpenFileDialog()
                openDLG.FileName = "D:\tests\PCB-Investigator-Design.exe"
                openDLG.Title = "Please select PCB-Investigator Embedded Design"
                If openDLG.ShowDialog() <> DialogResult.OK Then
                    Return
                End If
                mainWindowPCBI = IAutomation.OpenEmbeddedDesign(openDLG.FileName, True)
            End If
            If mainWindowPCBI.GetCurrentStep() Is Nothing Then
                MessageBox.Show("Please select an PCB-Investigator embedded design to use this demo.", "No Job loaded!", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
            End If
            Dim filter As IFilter = New IFilter(mainWindowPCBI)
            Dim layer As IODBLayer = filter.CreateEmptyODBLayer("layer_test", mainWindowPCBI.GetCurrentStep().Name)
            Dim index As Integer = IFilter.AddToolDefinitionRound(layer, 10.0F, 0)
            Dim index2 As Integer = IFilter.AddToolDefinitionRect(layer, 20.0F, 1, 20.0F, 50.0F, True)
            Dim index3 As Integer = IFilter.AddToolDefinitionDonut(layer, 50.0F, 25.0F, 2)
            Dim index4 As Integer = IFilter.AddToolDefinitionOct(layer, 40.0F, 40.0F, 40.0F, 5.0F, 3)
            Dim pad As IODBObject = filter.CreatePad(layer)
            pad.SetSpecifics(New IPadSpecifics() With {.Location = New PointF(400.0F, 400.0F), .Positive = True}, index)
        End Sub

        Friend Function CreatePadFromString(ByVal pcbiFilter As IFilter, ByVal parentLayer As IODBLayer, ByVal location As PointF, ByVal ODBString As String, ByVal symbolType As Symbol_Type) As Integer
            Dim pad As IODBObject = pcbiFilter.CreatePad(parentLayer)
            Dim specPad As IPadSpecifics = CType(pad.GetSpecifics(), IPadSpecifics)
            specPad.Location = location
            specPad.ShapeIndex = IFilter.AddToolFromODBString(parentLayer, ODBString, -1)
            specPad.Positive = True
            specPad.Type = symbolType
            pad.SetSpecifics(specPad, specPad.ShapeIndex)
            Return specPad.ShapeIndex
        End Function

        Friend Shared Function CreateSpecialPad(ByVal pcbiFilter As IFilter, ByVal parentLayer As IODBLayer, ByVal Location As PointF, ByVal OutlineOfSpecialPad As List(Of Form1.ExampleSurface.Grf_Object)) As Integer
            Dim t As IODBObject = pcbiFilter.CreateOutlinePolygon()
            Dim outline As ISurfaceSpecifics = CType(t.GetSpecifics(), ISurfaceSpecifics)
            Dim padODB As IODBObject = Nothing
            Dim specPad As IPadSpecifics = Nothing
            Dim started As Boolean = False
            For Each obj As Form1.ExampleSurface.Grf_Object In OutlineOfSpecialPad
                If TypeOf obj Is Form1.ExampleSurface.Grf_Line Then
                    Dim line As Form1.ExampleSurface.Grf_Line = CType(obj, Form1.ExampleSurface.Grf_Line)
                    If Not started Then
                        started = True
                        outline.StartPolygon(False, line.Start)
                    End If
                    outline.AddLine(line.Start, line.[End])
                Else
                    If TypeOf obj Is Form1.ExampleSurface.Grf_Arc Then
                        Dim arc As Form1.ExampleSurface.Grf_Arc = CType(obj, Form1.ExampleSurface.Grf_Arc)
                        If Not started Then
                            started = True
                            outline.StartPolygon(False, arc.Start)
                        End If
                        outline.AddArc(arc.Start, arc.[End], arc.Center, arc.Clockwise)
                    End If
                End If
            Next
            outline.EndPolygon()
            Dim bounds As RectangleF = outline.GetBounds()
            If padODB Is Nothing Then
                padODB = pcbiFilter.CreatePad(parentLayer)
            End If
            If specPad Is Nothing Then
                specPad = CType(padODB.GetSpecifics(), IPadSpecifics)
            End If
            Dim symbolList As Dictionary(Of Integer, IFilter.ToolDefinition) = pcbiFilter.GetUsedSymbolList(parentLayer)
            specPad.ShapeIndex = pcbiFilter.AddToolDefinitionSpecial(parentLayer, "special_name of pad", outline, outline.GetBounds().Width, symbolList.Count + 1)
            specPad.Positive = True
            specPad.Type = Symbol_Type.special
            specPad.Location.X = Location.X
            specPad.Location.Y = Location.Y
            padODB.SetSpecifics(specPad, specPad.ShapeIndex)
            Return specPad.ShapeIndex
        End Function
    End Class
End Namespace
